#include "../perm/perm.h"

/*@ predicate is_injEndo{L}(int *a, integer n) = 
     is_linear(a,n) && is_endofct(a,n); */

// Function declarations

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_endofct(a,n);
  @ assigns \nothing;
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 <==> is_injEndo(a,n); */
int b_injEndo(int a[], int n);

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_injEndo(a,n); */
int first_injEndo(int a[], int n);

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_injEndo(a,n);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_injEndo(a,n);
  @ ensures \result == 1 ==> lt_lex{Pre,Post}(a,n); */
int next_injEndo(int a[], int n);
